package jumpstart.web.components.examples.wizard;

import jumpstart.web.commons.ExceptionUtil;
import jumpstart.web.state.examples.wizard.CreditRequest;

import org.apache.tapestry5.BindingConstants;
import org.apache.tapestry5.annotations.Component;
import org.apache.tapestry5.annotations.Parameter;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.corelib.components.Form;

public class WizardUsingComponentsSubmit {

	@Parameter(defaultPrefix = BindingConstants.PROP)
	@Property
	private CreditRequest _creditRequest;

	@Component(id = "form")
	private Form _form;

	void onValidateForm() {
		try {
			// In the real world we would probably submit it to the business layer here
			// but we're not, so let's complete the request and simulate a waiting period! 
			_creditRequest.complete();
			sleep(5000);
		}
		catch (Exception e) {
			_form.recordError(ExceptionUtil.getRootCause(e));
		}
	}

	private void sleep(long millis) {
		try {
			Thread.sleep(millis);
		}
		catch (InterruptedException e) {
			// Ignore
		}
	}

}