package jumpstart.web.pages.examples.infrastructure;

import jumpstart.business.domain.examples.Person;
import jumpstart.business.domain.examples.iface.IPersonServiceLocal;
import jumpstart.web.services.IBusinessServicesLocator;

import org.apache.tapestry5.ioc.annotations.Inject;

public class HandlingABadContext {
	
	private Long _personId;

	private Person _person;
	
	@Inject
	private IBusinessServicesLocator _businessServicesLocator;

	Long onPassivate() {
		return _personId;
	}
	
	void onActivate(Long personId) {
		_personId = personId;
		// Get person - ask business service to find it (from the database)
		_person = getPersonService().findPerson(personId);
	}
	
	private IPersonServiceLocal getPersonService() {
		// Use our business services locator to get the EJB3 session bean called "PersonServiceLocal".
		return _businessServicesLocator.getPersonServiceLocal();
	}
	
	public Long getPersonId() {
		return _personId;
	}
	
	public Person getPerson() {
		return _person;
	}
}
