package jumpstart.web.pages.examples.navigation;

import jumpstart.business.domain.examples.Person;
import jumpstart.business.domain.examples.iface.IPersonServiceLocal;
import jumpstart.web.services.IBusinessServicesLocator;

import org.apache.tapestry5.ioc.annotations.Inject;

public class ActivationContext2 {

	private Person _person;

	@Inject
	private IBusinessServicesLocator _businessServicesLocator;
	
	// onActivate() is called by Tapestry to pass in the activation context from the URL.

	void onActivate(Long personId) throws Exception {
		// Get person - ask business service to find it (from the database)
		_person = getPersonService().findPerson(personId);

		if (_person == null) {
			throw new Exception("Database data has not been set up!");
		}
	}

	private IPersonServiceLocal getPersonService() {
		return _businessServicesLocator.getPersonServiceLocal();
	}

	public Person getPerson() {
		return _person;
	}
}
