package jumpstart.web.pages.examples.navigation;

import jumpstart.business.domain.examples.Person;
import jumpstart.business.domain.examples.iface.IPersonServiceLocal;
import jumpstart.web.services.IBusinessServicesLocator;

import org.apache.tapestry5.ioc.annotations.Inject;

public class OnActivateAndOnPassivate {

	private Person _person;

	@Inject
	private IBusinessServicesLocator _businessServicesLocator;

	Long onPassivate() {
		// Convert our Person into an id.
		return _person.getId();
	}

	void onActivate(Long personId) throws Exception {
		// Convert the id into a Person.
		_person = getPersonService().findPerson(personId);
		if (_person == null) {
			throw new Exception("Database data has not been set up!");
		}
	}

	private IPersonServiceLocal getPersonService() {
		return _businessServicesLocator.getPersonServiceLocal();
	}

	public Person getPerson() {
		return _person;
	}
}
