package jumpstart.web.pages.examples.navigation;

import jumpstart.business.domain.examples.Person;
import jumpstart.business.domain.examples.iface.IPersonServiceLocal;
import jumpstart.web.pages.Index;
import jumpstart.web.services.IBusinessServicesLocator;

import org.apache.tapestry5.ComponentResources;
import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.ioc.annotations.Inject;

public class PageLinkOrActionLink2 {

	private Long _personId;

	@Persist
	private Person _person;

	@Inject
	private IBusinessServicesLocator _businessServicesLocator;

	@Inject
	private ComponentResources _resources;

	// set() is public so that other pages can use it to set up this page.

	public void set(Long personId) throws Exception {
		_personId = personId;
		
		// For the purpose of this demonstration we will throw an exception if person doesn't exist.
		
		Person person = getPersonService().findPerson(_personId);
		if (person == null) {
			throw new Exception("Person " + _personId + " does not exist.");
		}
	}
	
	// onPassivate() is called by Tapestry to get the activation context to put in the URL.
	
	Long onPassivate() {
		return _personId;
	}

	// onActivate() is called by Tapestry to pass in the activation context from the URL.

	void onActivate(Long personId) throws Exception {
		_personId = personId;
		_person = getPersonService().findPerson(_personId);

		if (_person == null) {
			if (_personId < 4) {
				throw new IllegalStateException("Database data has not been set up!");
			}
			else {
				throw new Exception("Person " + _personId + " does not exist.");
			}
		}
	}
	
	Object onActionFromReturn() {
		_resources.discardPersistentFieldChanges();
		return PageLinkOrActionLink1.class;
	}
	
	Object onActionFromGoHome() {
		_resources.discardPersistentFieldChanges();
		return Index.class;
	}
	
	private IPersonServiceLocal getPersonService() {
		return _businessServicesLocator.getPersonServiceLocal();
	}

	public Person getPerson() {
		return _person;
	}
}
