package jumpstart.web.pages.examples.navigation;

import jumpstart.web.pages.Index;

import org.apache.tapestry5.ComponentResources;
import org.apache.tapestry5.Link;
import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.ioc.annotations.Inject;

public class ReturnToPage2 {

	private String _message;

	@Persist
	private Link _returnTo;

	@Inject
	private ComponentResources _componentResources;

	public void set(String message, Link returnTo) {
		_message = message;
		_returnTo = returnTo;
	}

	String onPassivate() {
		return _message;
	}

	void onActivate(String message) {
		_message = message;
	}

	Link onActionFromReturn() {
		_componentResources.discardPersistentFieldChanges();
		return _returnTo;
	}

	Object onActionFromGoHome() {
		_componentResources.discardPersistentFieldChanges();
		return Index.class;
	}

	public String getMessageFromCaller() {
		return _message;
	}

	public Link getReturnTo() {
		return _returnTo;
	}
}
