package jumpstart.web.pages.examples.navigation;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.tapestry5.ComponentResources;
import org.apache.tapestry5.Link;
import org.apache.tapestry5.PersistenceConstants;
import org.apache.tapestry5.StreamResponse;
import org.apache.tapestry5.annotations.InjectPage;
import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.services.Response;

public class ReturnTypes1 {

	@SuppressWarnings("unused")
	@Persist(PersistenceConstants.FLASH)
	@Property
	private String _message;

	void onActionFromReturnVoid() {
		_message = "You chose to return void.";
	}

	Object onActionFromReturnNull() {
		_message = "You chose to return null.";
		return null;
	}

	@SuppressWarnings("unchecked")
	Class onActionFromReturnClass() {
		return ReturnTypesClass.class;
	}

	@InjectPage
	private ReturnTypesPageObject _pageObject;

	Object onActionFromReturnPageObject() {
		_pageObject.set("Hello");
		return _pageObject;
	}

	String onActionFromReturnString() {
		return "examples/navigation/ReturnTypesString";
	}

	@Inject
	private ComponentResources _resources;

	Link onActionFromReturnLink() {
		String parameters = "Howdy";
		Link link = _resources.createPageLink(ReturnTypesLink.class, false, parameters);
		return link;
	}

	StreamResponse onActionFromReturnStreamResponse() {
		return new StreamResponse() {

			public String getContentType() {
				return "text/plain";
			}

			public InputStream getStream() throws IOException {
				ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
				InputStream resourceStream = classLoader
						.getResourceAsStream("jumpstart/web/text/examples/ReturnTypeText.txt");
				return resourceStream;
			}

			public void prepareResponse(Response response) {
			}
		};
	}

	URL onActionFromReturnURL() throws MalformedURLException {
		return new URL("http://tapestry.apache.org/tapestry5/");
	}

	boolean onActionFromReturnTrue() {
		_message = "You chose to return true.";
		return true;
	}

	boolean onActionFromReturnFalse() {
		_message = "You chose to return false.";
		return false;
	}
}
