package jumpstart.web.pages.examples.select;

import java.util.List;

import jumpstart.business.domain.examples.Person;
import jumpstart.business.domain.examples.iface.IPersonServiceLocal;
import jumpstart.web.commons.IdSelectModel;
import jumpstart.web.services.IBusinessServicesLocator;

import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.ioc.annotations.Inject;
import org.apache.tapestry5.ioc.services.PropertyAccess;

public class EasyIdSelect {

	@SuppressWarnings("unused")
	@Property
	@Persist
	private IdSelectModel<Person> _personIds;

	@Property
	private Long _personId;
	
	@SuppressWarnings("unused")
	@Property
	private Person _person;
	
	@Inject
	private IBusinessServicesLocator _businessServicesLocator;
	
	@Inject
	private PropertyAccess _propertyAccess;
	
	Long onPassivate() {
		return _personId;
	}

	void onActivate(Long personId) {
		_personId = personId;
	}

	void onActivate() {
		refreshPersons();
	}

	void refreshPersons() {
		// Get all persons - ask business service to find them (from the database)
		List<Person> persons = getPersonService().findPersons();
		_personIds = new IdSelectModel<Person>(persons, Person.class, "firstName", "id", _propertyAccess);
	}

	private IPersonServiceLocal getPersonService() {
		// Use our business services locator to get the EJB3 session bean called "PersonServiceLocal".
		return _businessServicesLocator.getPersonServiceLocal();
	}
	
}