package jumpstart.web.pages.examples.styling;

import org.apache.tapestry5.Asset;
import org.apache.tapestry5.PersistenceConstants;
import org.apache.tapestry5.annotations.Path;
import org.apache.tapestry5.annotations.Persist;
import org.apache.tapestry5.annotations.Property;
import org.apache.tapestry5.ioc.annotations.Inject;

public class SwitchableStylesheets {

	private int _styleNum;
	
	@SuppressWarnings("unused")
	@Persist(PersistenceConstants.FLASH)
	@Property
	private String _firstName;

	@SuppressWarnings("unused")
	@Persist(PersistenceConstants.FLASH)
	@Property
	private String _lastName;

	@Inject
	@Path("context:css/examples/examples.css")
	private Asset _stylesheet0;

	@Inject
	@Path("context:css/examples/switched.css")
	private Asset _stylesheet1;
	
	int onPassivate() {
		return _styleNum;
	}
	
	void onActivate(int styleNum) {
		_styleNum = styleNum;
	}
	
	void onSuccess() {
		_styleNum = (_styleNum + 1) % 2;
	}
	
	public Asset getStylesheet() {
		switch (_styleNum) {
		case 0:
			return _stylesheet0;
		case 1:
			return _stylesheet1;
		default:
			return _stylesheet0;
		}
	}
}
