package jumpstart.web.pages.examples.tables;

import java.util.List;

import jumpstart.business.domain.examples.Person;
import jumpstart.business.domain.examples.iface.IPersonServiceLocal;
import jumpstart.web.services.IBusinessServicesLocator;

import org.apache.tapestry5.annotations.InjectComponent;
import org.apache.tapestry5.corelib.components.Grid;
import org.apache.tapestry5.ioc.annotations.Inject;

public class SortedGrid {

	private List<Person> _persons;

	@Inject
	private IBusinessServicesLocator _businessServicesLocator;

	@InjectComponent
	private Grid _grid;

	void setupRender() {
		// Get all persons - ask business service to find them (from the database)
		_persons = getPersonService().findPersons();
		 
		if (_grid.getSortModel().getSortConstraints().isEmpty()) {
			_grid.getSortModel().updateSort("startDate");
		}
	}
	private IPersonServiceLocal getPersonService() {
		// Use our business services locator to get the EJB3 session bean called "PersonServiceLocal".
		return _businessServicesLocator.getPersonServiceLocal();
	}

	public List<Person> getPersons() {
		return _persons;
	}
}
