package jumpstart.web.pages.examples.wizard;

import jumpstart.web.base.examples.wizard.WizardUsingPagesBase;
import jumpstart.web.commons.ExceptionUtil;

import org.apache.tapestry5.annotations.Component;
import org.apache.tapestry5.corelib.components.Form;

public class WizardUsingPagesApplicant extends WizardUsingPagesBase {

	@Component(id = "form")
	private Form _form;

	public void set(String conversationId) {
		setConversationId(conversationId);
	}
	
	String onPassivate() {
		return getConversationId();
	}

	Object onActivate(String conversationId) throws Exception {
		return activate(Step.APPLICANT, conversationId);
	}

	void onValidateForm() {
		try {
			getCreditRequest().validateApplicantInfo();
		}
		catch (Exception e) {
			// Display the cause. In a real system we would try harder to get a user-friendly message.
			_form.recordError(ExceptionUtil.getRootCause(e));
		}
	}

}