package jumpstart.web.pages.examples.wizard;

import jumpstart.web.base.examples.wizard.WizardUsingPagesBase;
import jumpstart.web.commons.ExceptionUtil;

import org.apache.tapestry5.annotations.Component;
import org.apache.tapestry5.corelib.components.Form;

public class WizardUsingPagesSubmit extends WizardUsingPagesBase {

	@Component(id = "form")
	private Form _form;

	public void set(String conversationId) {
		setConversationId(conversationId);
	}

	String onPassivate() {
		return getConversationId();
	}

	Object onActivate(String conversationId) throws Exception {
		return activate(Step.SUBMIT, conversationId);
	}

	void onValidateForm() {
		try {
			// In the real world we would probably submit it to the business layer here
			// but we're not, so let's simulate a busy period then complete the request!
	
			sleep(5000);
			getCreditRequest().complete();
		}
		catch (Exception e) {
			// Display the cause. In a real system we would try harder to get a user-friendly message.
			_form.recordError(ExceptionUtil.getRootCause(e));
		}
	}

	private void sleep(long millis) {
		try {
			Thread.sleep(millis);
		}
		catch (InterruptedException e) {
			// Ignore
		}
	}
}